﻿@using System.Web.UI.WebControls;
@using Portal.Models.PackingIndicatorMaster;
@using System.Web.Util
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper;
@using Toyota.Common.Web.MVC;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;

@Html.Common().DevExpress().GridView(
settings =>
{
    settings.Name = "PackingIndicatorInquiry";
    settings.KeyFieldName = "KEYF";
    settings.CallbackRouteValues = new { Controller = "PackingIndicatorMaster", Action = "PackingIndicatorMasterInquiryPartial" };
    
    settings.ClientSideEvents.BeginCallback = "OnOIPViewBeginCallback";
 
    
    settings.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);

    settings.CommandColumn.Visible = true;
    settings.CommandColumn.ShowSelectCheckbox = true;
    settings.CommandColumn.Width = 35;
    settings.CommandColumn.ClearFilterButton.Visible = true;
    
    settings.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
    settings.Settings.ShowFilterRow = true;
    settings.Settings.ShowFilterRowMenu = true;
    settings.SettingsPager.PageSizeItemSettings.Visible = true;
    settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    settings.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

    settings.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        string[] fnames = new string[] {"MAT_NO"
            , "SOURCE_TYPE"
            , "PROD_PURPOSE_CD"
            , "PART_COLOR_SFX"
            , "MAT_DESC"
            , "DOCK_CD"            
            , "PACKING_TYPE_CD"
            , "VALID_DT_FR"
            , "VALID_DT_TO"
            , "CREATED_BY"
            , "CREATED_DT"
            , "CHANGED_BY"
            , "CHANGED_DT"};

        List<List<string>> l = new List<List<string>>();
        for (int n = startIndex; n < end; n++)
        {
            List<string> m = new List<string>();
            foreach ( var f in fnames) {
                string v = Convert.ToString(grid.GetRowValues(n, f));
                m.Add(v);
            }
            l.Add(m);  
        }
        e.Properties["cpData"] = l;
        e.Properties["cpMode"] = "";
    };

    settings.Columns.Add(
     field =>
     {
         field.Caption = "Material No";
         field.FieldName = "MAT_NO";
         field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
         field.Width = Unit.Pixel(150);
     
     });

    settings.Columns.Add(
       field =>
       {
           field.Caption = "Source<br/>Type";
           field.FieldName = "SOURCE_TYPE";
           field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
           field.Width = Unit.Pixel(100);
         
       });
    settings.Columns.Add(
       field =>
       {
           field.Caption = "Prod<br/>Purpose";
           field.FieldName = "PROD_PURPOSE_CD";
           field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
           field.Width = Unit.Pixel(100);
         
       });

    settings.Columns.Add(
       field =>
       {
           field.Caption = "Part Color<br/>Suffix";
           field.FieldName = "PART_COLOR_SFX";
           field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
           field.Width = Unit.Pixel(100);
         
       });

    settings.Columns.Add(
       field =>
       {
           field.Caption = "Material<br/>Description";
           field.FieldName = "MAT_DESC";
           field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
           field.Width = Unit.Pixel(150);
          
       });

    settings.Columns.Add(
        field =>
        {
            field.Caption = "Dock<br/>Code";
            field.FieldName = "DOCK_CD";
            field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            field.Width = Unit.Pixel(100);
       
        });

    settings.Columns.Add(
        field =>
        {
            field.Caption = "Packing<br/>Type";
            field.FieldName = "PACKING_TYPE_CD";
            field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            field.Width = Unit.Pixel(100);
           
        });

    settings.Columns.Add(
        field =>
        {
            field.Caption = "Valid From";
            field.FieldName = "VALID_DT_FR";
            field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            field.Width = Unit.Pixel(100);
           
        });

    settings.Columns.Add(
        field =>
        {
            field.Caption = "Valid To";
            field.FieldName = "VALID_DT_TO";
            field.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            field.Width = Unit.Pixel(100);
            
        });

    settings.Columns.AddBand(tmminBand =>
    {
        tmminBand.Name = "OIPCreateBand";
        tmminBand.Caption = "Created";
        tmminBand.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        tmminBand.Columns.Add(column =>
        {
            column.FieldName = "CREATED_BY";
            column.Caption = "By";
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.Width = Unit.Pixel(100);
        });

        tmminBand.Columns.Add(column =>
        {
            column.FieldName = "CREATED_DT";
            column.Caption = "Date";
            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:MM:ss";
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(100);
            column.PropertiesEdit.NullDisplayText = string.Empty;
        });
    });

    settings.Columns.AddBand(tmminBand =>
    {
        tmminBand.Name = "OIPChangedBand";
        tmminBand.Caption = "Changed";
        tmminBand.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        tmminBand.Columns.Add(column =>
        {
            column.FieldName = "CHANGED_BY";
            column.Caption = "By";
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.Width = Unit.Pixel(100);
        });

        tmminBand.Columns.Add(column =>
        {
            column.FieldName = "CHANGED_DT";
            column.Caption = "Date";
            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy hh:MM:ss";
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(100);
            column.PropertiesEdit.NullDisplayText = string.Empty;
        });
    });

    settings.Columns.Add(
        f =>
        {
            f.Caption = "KeyFields";
            f.FieldName = "KEYF";
            f.Visible = false;           
        }
    );

}).Bind(Model.GetModel<Portal.Models.PackingIndicatorMaster.PackingIndicatorMasterModel>().PackingIndicatorMasterDatas).GetHtml()